<template>
  <el-dialog :visible.sync="visible" :title="!dataForm.ptsid ? $t('add') : $t('update')" :close-on-click-modal="false" :close-on-press-escape="false">
    <el-form :model="dataForm" :rules="dataRule" ref="dataForm" @keyup.enter.native="dataFormSubmitHandle()" :label-width="$i18n.locale === 'en-US' ? '120px' : '80px'">
          <el-form-item label="" prop="title">
          <el-input v-model="dataForm.title" placeholder=""></el-input>
      </el-form-item>
          <el-form-item label="" prop="content">
          <el-input v-model="dataForm.content" placeholder=""></el-input>
      </el-form-item>
          <el-form-item label="" prop="typeid">
          <el-input v-model="dataForm.typeid" placeholder=""></el-input>
      </el-form-item>
            <el-form-item label="" prop="taix">
          <el-input v-model="dataForm.taix" placeholder=""></el-input>
      </el-form-item>
          <el-form-item label="" prop="thumbnail">
          <el-input v-model="dataForm.thumbnail" placeholder=""></el-input>
      </el-form-item>
          <el-form-item label="统计" prop="count">
          <el-input v-model="dataForm.count" placeholder="统计"></el-input>
      </el-form-item>
        </el-form>
    <template slot="footer">
      <el-button @click="visible = false">{{ $t('cancel') }}</el-button>
      <el-button type="primary" @click="dataFormSubmitHandle()">{{ $t('confirm') }}</el-button>
    </template>
  </el-dialog>
</template>

<script>
import debounce from 'lodash/debounce'
export default {
  data () {
    return {
      visible: false,
      dataForm: {
        ptsid: '',
        title: '',
        content: '',
        typeid: '',
        creator: '',
        taix: '',
        thumbnail: '',
        count: '',
        createDate: ''
      }
    }
  },
  computed: {
    dataRule () {
      return {
        title: [
          { required: true, message: this.$t('validate.required'), trigger: 'blur' }
        ],
        content: [
          { required: true, message: this.$t('validate.required'), trigger: 'blur' }
        ],
        typeid: [
          { required: true, message: this.$t('validate.required'), trigger: 'blur' }
        ],
        taix: [
          { required: true, message: this.$t('validate.required'), trigger: 'blur' }
        ],
        thumbnail: [
          { required: true, message: this.$t('validate.required'), trigger: 'blur' }
        ],
        count: [
          { required: true, message: this.$t('validate.required'), trigger: 'blur' }
        ],
      }
    }
  },
  methods: {
    init () {
      this.visible = true
      this.$nextTick(() => {
        this.$refs['dataForm'].resetFields()
        if (this.dataForm.id) {
          this.getInfo()
        }
      })
    },
    // 获取信息
    getInfo () {
      this.$http.get(`/cniyv/cniyvarticle/${this.dataForm.id}`).then(({ data: res }) => {
        if (res.code !== 0) {
          return this.$message.error(res.msg)
        }
        this.dataForm = {
          ...this.dataForm,
          ...res.data
        }
      }).catch(() => {})
    },
    // 表单提交
    dataFormSubmitHandle: debounce(function () {
      this.$refs['dataForm'].validate((valid) => {
        if (!valid) {
          return false
        }
        this.$http[!this.dataForm.ptsid ? 'post' : 'put']('/cniyv/cniyvarticle/', this.dataForm).then(({ data: res }) => {
          if (res.code !== 0) {
            return this.$message.error(res.msg)
          }
          this.$message({
            message: this.$t('prompt.success'),
            type: 'success',
            duration: 500,
            onClose: () => {
              this.visible = false
              this.$emit('refreshDataList')
            }
          })
        }).catch(() => {})
      })
    }, 1000, { 'leading': true, 'trailing': false })
  }
}
</script>
